import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.security.*;
public class ChatApplet extends JFrame{
private JPanel contentPane;
private JTextArea incoming;
private JScrollPane scroll;
private JPanel sendPane;
private JTextField output;
private JButton submit;

private String inputActive;
private String username;
private Socket socket;
private int port;
private String codedIP;
protected static ChatApplet instance;
private CommandManager man;
    public ChatApplet(){
        instance = this;
        man = new CommandManager();
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        inputActive = null;
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(new BorderLayout(5, 5));
        incoming = new JTextArea(50, 70);
        incoming.setLineWrap(true);
        incoming.setEditable(false);
        scroll = new JScrollPane(incoming);
        scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        sendPane = new JPanel();
        sendPane.setLayout(new BoxLayout(sendPane, BoxLayout.X_AXIS));
        output = new JTextField(40);
        output.addKeyListener(new EnterListener());
        submit = new JButton("Abschicken");
        submit.setEnabled(false);
        submit.addActionListener(new SubmitListener());
        sendPane.add(output);
        sendPane.add(submit);
        contentPane.add(scroll, BorderLayout.CENTER);
        contentPane.add(sendPane, BorderLayout.SOUTH);
        this.setSize(550,600);
        this.setVisible(true);
    }
    public static void main(String[] args){
        new ChatApplet().setup();
    }
    private class Starter implements Runnable{
        public void run(){
            instance.setup();
        }
    }
    private class SubmitListener implements ActionListener{
        public void actionPerformed(ActionEvent e){
            inputActive = output.getText();
        }
    }
    private class IncomingListener implements Runnable{
        public void run(){
            try{
                Socket sock = socket;
                BufferedReader reader = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                while(sock.isConnected()){
                    String in = null;
                    if((in = reader.readLine()) != null){
                        if(in.startsWith("/")){
                            man.sendRequest(in);
                        }else{
                            String[] message = in.split("#");
                            println(message[0]+": "+message[1]);
                        }
                    }
                }
            }catch(Exception ex){ex.printStackTrace(); println("Ein Verbindungsfehler ist aufgetreten");}
        }
    }
    public class EnterListener implements KeyListener{
        public void keyPressed(KeyEvent e){
            if(e.getKeyCode() == KeyEvent.VK_ENTER){
                submit.doClick();
            }
        }
        public void keyReleased(KeyEvent e){}
        public void keyTyped(KeyEvent e){}
    }
    public void println(String txt){
        incoming.append(txt+"\n");
    }
    public void print(String txt){
        incoming.append(txt);
    }
    public String readLine(){
        output.requestFocus();
        submit.setEnabled(true);
        while (inputActive == null) {}
        submit.setEnabled(false);
        String retinput = inputActive;
        output.setText("");
        inputActive = null;
        println(retinput);
        return retinput;
    }
    public void setup(){
        try{
            print("Geben Sie die IP und den Port des Servers an:  ");
            String old = lastData();
            if(old != null){
                output.setText(old);
            }
            codedIP = readLine();
            String[] parts = codedIP.split(":");
            String ip = parts[0];
            port = Integer.parseInt(parts[1]);
            getUser();
            println("Verbinde ...");
            socket = new Socket(ip, port);
            PrintWriter writer = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
            writer.println(username);
            writer.flush();
            println("Mit dem Server verbunden");
            saveData(codedIP);
            Thread t = new Thread(new IncomingListener());
            t.start();
            writing();
        }catch(Exception ex){ex.printStackTrace();println("Ein Fehler ist aufgetreten");}
    }
    public String lastData(){
        String data = null;
        try{
            File f = new File("lastlogin.log");
            if(f.exists()){
                BufferedReader reader = new BufferedReader(new FileReader(f));
                data = reader.readLine();
                reader.close();
            }
        }catch(Exception ex){ex.printStackTrace();}
        return data;
    }
    public void saveData(String data){
        try{
            File f = new File("lastlogin.log");
            if(!f.exists()){
                f.createNewFile();
            }
            PrintWriter writer = new PrintWriter(new FileWriter(f));
            writer.println(data);
            writer.flush();
            writer.close();
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void writing(){
        try{
            Socket sock = socket;
            PrintWriter writer = new PrintWriter(new OutputStreamWriter(sock.getOutputStream()));
            while(sock.isConnected()){
                String input = readLine();
                if(sock.isConnected()){
                    writer.println(username+"#"+input);
                    writer.flush();
                }
            }
        }catch(Exception ex){ex.printStackTrace();println("Ein Verbindungsfehler ist aufgetreten");}
    }
    public void getUser(){
        if(true){
            AccessController.doPrivileged(new PrivilegedAction(){
                public Object run(){
                    username = System.getProperty("user.name");
                    return null;
                }
            });
        }else{
            println("Geben Sie ihren Benutzernamen an:");
            username = readLine();
        }
    }
}
