import javax.io.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
public class ChatServer implements Serializable{
static transient HashMap<String, Socket> clients;
static transient ChatServer me;
private transient ListLoader listLoader;
private transient ControlManager man;
private transient ServerControlManager svrMan;
private transient UserControlManager userMan;
private transient WritingTypeManager wrMan;
private transient UserList blacklist;
private transient UserList whitelist;
private transient UserList bans;
private transient UserList ops;
private transient UserList admins;
public transient UserList afks;
public transient UserList jokers;
public transient UserList muted;
public transient String[] jokerMessages;
public transient int usersAllowed;
public transient int usersConnected;
public transient String protocoll;
private transient boolean protocollActivated;
    public static void main(String[] args){
        new ChatServer().run();
    }
    public void run(){
        try{
            usersAllowed = 40;
            usersConnected = 0;
            protocollActivated = true;
            me = this;
            listLoader = new ListLoader();
            blacklist = new UserList(new BlackListAction());
            whitelist = new UserList(new WhiteListAction());
            ops = new UserList(new NullListAction());
            admins = new UserList(new NullListAction());
            afks = new UserList(new NullListAction());
            jokers = new UserList(new NullListAction());
            muted = new UserList(new NullListAction());
            man = new ControlManager();
            svrMan = new ServerControlManager();
            userMan = new UserControlManager();
            wrMan = new WritingTypeManager();
            File settingsDir = new File("settings");
            if(!settingsDir.exists()){
                settingsDir.mkdir();
            }
            File protocollDir = new File("protocolls");
            if(!protocollDir.exists()){
                protocollDir.mkdir();
            }
            File listsDir = new File("lists");
            if(!listsDir.exists()){
                listsDir.mkdir();
            }
            File banFile = new File("settings\\ban.ser");
            if(!banFile.exists()){
                banFile.createNewFile();
                bans = new UserList(new BanListAction());
                bans.setEnabled(true);
                listLoader.saveList(banFile, bans);
            }else{
                bans = listLoader.loadList(banFile, new UserList(new BanListAction()), new BanListAction());
                bans.update();
            }
            File opFile = new File("settings\\ops.ser");
            if(!opFile.exists()){
                opFile.createNewFile();
                ops = new UserList(new NullListAction());
                ops.setEnabled(true);
                listLoader.saveList(opFile, ops);
            }else{
                ops = listLoader.loadList(opFile, new UserList(new NullListAction()), new NullListAction());
                ops.update();
            }
            File adminFile = new File("settings\\admins.ser");
            if(!adminFile.exists()){
                adminFile.createNewFile();
                admins = new UserList(new NullListAction());
                admins.setEnabled(true);
                listLoader.saveList(adminFile, admins);
            }else{
                admins = listLoader.loadList(adminFile, new UserList(new NullListAction()), new NullListAction());
                admins.update();
            }
            File jokerFile = new File("settings\\jokerMsg.txt");
            if(!jokerFile.exists()){
                jokerFile.createNewFile();
                jokerMessages = new String[]{"Hahaha"};
            }else{
                loadJokerMessages(jokerFile);
            }
            CMD.createWindow();
            CMD.setButtonDisabling(false);
            CMD.addWindowListener(new ServerWindowListener());
            CMD.out.println("Geben Sie den Serverport ein (4-stellige Zahl):");
            String port = CMD.in.readLine();
            int iport = Integer.parseInt(port);
            clients = new HashMap<String, Socket>();
            ServerSocket server = new ServerSocket(iport);
            String ip = InetAddress.getLocalHost().getHostAddress();
            CMD.out.println("Server aufgebaut!\nDaten: "+ip+":"+port);
            Thread control = new Thread(new ServerControl());
            control.start();
            while(true){
                Socket sock = server.accept();
                BufferedReader tr = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                
                String name = tr.readLine();
                clients.put(name, sock);
                whitelist.update();
                blacklist.update();
                bans.update();
                if((blacklist.isEnabled() & blacklist.isUserListed(name)) | (whitelist.isEnabled() & !whitelist.isUserListed(name)) | bans.isUserListed(name)){
                    sendUserMessage("Server", name, "Sie dürfen nicht am Chat teilnehmen");
                    man.sendRequest("Server", "/kick " + name);
                }else if(usersConnected == usersAllowed){
                    sendUserMessage("Server", name, "Keine freien Slots mehr verfügbar");
                    man.sendRequest("Server", "/kick " + name);
                }else{
                    sendToAll("Server#"+name+" hat sich angemeldet");
                    usersConnected++;
                    Thread cT = new Thread(new ClientListener(sock, tr, name));
                    cT.start();
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendToAll(String txt){
        try{
            String[] me = txt.split("#");
            if(muted.isUserListed(me[0])){
                CMD.out.println(me[0] + "(mute): " + me[1]);
                if(protocollActivated){
                    protocoll += (me[0]+"(mute): "+me[1]+";");
                }
            }else if(jokers.isUserListed(me[0])){
                String msg = jokerMessages[new Random().nextInt(jokerMessages.length)];
                if(protocollActivated){
                    protocoll += (me[0]+": "+msg+";");
                }
                CMD.out.println(me[0]+": "+msg);
                Set<String> keys = clients.keySet();
                Iterator it = keys.iterator();
                while(it.hasNext()){
                    String client = (String) it.next();
                    if(!txt.split("#")[0].equals(client) & !muted.isUserListed(client)){
                        Socket cliSock = clients.get(client);
                        PrintWriter writer = new PrintWriter(new OutputStreamWriter(cliSock.getOutputStream()));
                        if(!cliSock.isOutputShutdown()){
                            writer.println(me[0] + "#" + msg);
                            writer.flush();
                        }
                    }
                }
            }else if(me[1].startsWith("/")  & admins.isUserListed(me[0])){
                svrMan.sendRequest(me[0], me[1]);
            }else if(me[1].startsWith("/") & ops.isUserListed(me[0])){
                man.sendRequest(me[0], me[1]);
            }else if(me[1].startsWith("/")){
                userMan.sendRequest(me[0], me[1]);
            }else{
                if(protocollActivated){
                    protocoll += (me[0]+": "+me[1]+";");
                }
                CMD.out.println(me[0]+": "+me[1]);
                Set<String> keys = clients.keySet();
                Iterator it = keys.iterator();
                while(it.hasNext()){
                    String client = (String) it.next();
                    if(!txt.split("#")[0].equals(client)){
                        Socket cliSock = clients.get(client);
                        PrintWriter writer = new PrintWriter(new OutputStreamWriter(cliSock.getOutputStream()));
                        if(!cliSock.isOutputShutdown()){
                            writer.println(txt);
                            writer.flush();
                        }
                    }
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendServerAnswer(String txt){
        try{
            String[] me = txt.split("#");
            if(protocollActivated){
                protocoll += (me[0]+": "+me[1]+";");
            }
            CMD.out.println(me[0]+": "+me[1]);
            Set<String> keys = clients.keySet();
            Iterator it = keys.iterator();
            while(it.hasNext()){
                String client = (String) it.next();
                Socket cliSock = clients.get(client);
                PrintWriter writer = new PrintWriter(new OutputStreamWriter(cliSock.getOutputStream()));
                if(!cliSock.isOutputShutdown()){
                    writer.println(txt);
                    writer.flush();
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    protected UserList getBlacklist(){
        return blacklist;
    }
    protected UserList getWhitelist(){
        return whitelist;
    }
    protected ListLoader getListLoader(){
        return listLoader;
    }
    protected ControlManager getControlManager(){
        return man;
    }
    protected UserList getBanList(){
        return bans;
    }
    protected UserList getOPList(){
        return ops;
    }
    protected UserList getAdminList(){
        return admins;
    }
    protected void setBanList(UserList ban){
        bans = ban;
    }
    protected void setBlackList(UserList black){
        blacklist = black;
    }
    protected void setWhiteList(UserList white){
        whitelist = white;
    }
    protected BlackListAction getBlackListAction(){
        return new BlackListAction();
    }
    protected WhiteListAction getWhiteListAction(){
        return new WhiteListAction();
    }
    private class ClientListener implements Runnable{
        BufferedReader reader;
        Socket client;
        String user;
        private ClientListener(Socket sock, BufferedReader read, String name){
            reader = read;
            client = sock;
            user = name;
        }
        public void run(){
            try{
                while(!client.isInputShutdown()){
                    String in;
                    if((in = reader.readLine()) != null){
                        sendToAll(in);
                    }
                }
            }catch(IOException io){
                sendToAll("Server#"+user+" hat sich abgemeldet");
                usersConnected--;
                clients.remove(user);
            }catch(Exception ex){ex.printStackTrace();}
        }
    }
    public class ServerControl implements Runnable{
        public void run(){
            try{
                while(true){
                    String command = CMD.in.readLine();
                    if(command.startsWith("/")){
                        svrMan.sendRequest("Server", command);
                    }else{
                        sendToAll("Server#" + command);
                    }
                }
            }catch(Exception ex){ex.printStackTrace();}
        }
    }
    public class BlackListAction implements ListAction, Serializable{
        public void runAction(ArrayList<String> list){
            Iterator it = list.iterator();
            while(it.hasNext()){
                String userEntry = (String) it.next();
                Socket tmpSocket;
                if((tmpSocket = clients.get(userEntry)) != null){
                    try{
                        sendUserMessage("Server", userEntry,  "Sie wurden aus dem Chat ausgeschlossen");
                        man.sendRequest("Server", "/kick " + userEntry);
                    }catch(Exception ex){ex.printStackTrace();}
                }
            }
        }
    }
    public class BanListAction implements ListAction, Serializable{
        public void runAction(ArrayList<String> list){
            Iterator it = list.iterator();
            while(it.hasNext()){
                String userEntry = (String) it.next();
                Socket tmpSocket;
                if((tmpSocket = clients.get(userEntry)) != null){
                    try{
                        sendUserMessage("Server", userEntry,  "Sie wurden vom Chat verbannt");
                        man.sendRequest("Server", "/kick " + userEntry);
                    }catch(Exception ex){ex.printStackTrace();}
                }
            }
        }
    }
    public class WhiteListAction implements ListAction, Serializable{
        public void runAction(ArrayList<String> list){
            Set<String> keys = clients.keySet();
            Iterator it = keys.iterator();
            while(it.hasNext()){
                String user = (String) it.next();
                if(!whitelist.isUserListed(user)){
                    try{
                        sendUserMessage("Server", user,  "Sie wurden aus dem Chat ausgeschlossen");
                        man.sendRequest("Server", "/kick " + user);
                    }catch(Exception ex){ex.printStackTrace();}
                }
            }
        }
    }
    public class NullListAction implements ListAction, Serializable{
        public void runAction(ArrayList<String> list){}
    }
    public class ServerWindowListener implements WindowListener{
        public void windowClosed(WindowEvent e){
            saveAndExit();
        }
        public void windowActivated(WindowEvent e){}
        public void windowClosing(WindowEvent e){}
        public void windowDeactivated(WindowEvent e){}
        public void windowDeiconified(WindowEvent e){}
        public void windowIconified(WindowEvent e){}
        public void windowOpened(WindowEvent e){}
    }
    public void addOP(String user){
        ops.addEntry(user);
    }
    public void removeOP(String user){
        ops.remove(user);
    }
    public boolean isOP(String user){
        return ops.isUserListed(user);
    }
    public void addAdmin(String user){
        admins.addEntry(user);
    }
    public void removeAdmin(String user){
        admins.remove(user);
    }
    public boolean isAdmin(String user){
        return admins.isUserListed(user);
    }
    public void sendUserMessage(String fromUser, String toUser, String message){
        try{
            Set<String> keys = clients.keySet();
            Iterator it = keys.iterator();
            while(it.hasNext()){
                String client = (String) it.next();
                if(client.equals(toUser)){
                    Socket cliSock = clients.get(client);
                    PrintWriter writer = new PrintWriter(new OutputStreamWriter(cliSock.getOutputStream()));
                    writer.println(fromUser + "#" + message);
                    writer.flush();
                }
            }
            if(protocollActivated){
                protocoll += (fromUser+": "+message+";");
            }
            CMD.out.println(fromUser+": "+message);
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendServerCommand(String userTo, String cmd){
        try{
            Socket sock = clients.get(userTo);
            if(sock != null & !muted.isUserListed(userTo)){
                PrintWriter pw = new PrintWriter(new OutputStreamWriter(sock.getOutputStream()));
                pw.println(cmd);
                pw.flush();
            }else if(userTo.equals("Server")){
                wrMan.sendRequest(cmd);
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendAllCommand(String cmd){
        try{
            Set<String> keys = clients.keySet();
            Iterator it = keys.iterator();
            while(it.hasNext()){
                String client = (String) it.next();
                Socket sock = clients.get(client);
                if(sock != null & !muted.isUserListed(client)){
                    PrintWriter pw = new PrintWriter(new OutputStreamWriter(sock.getOutputStream()));
                    pw.println(cmd);
                    pw.flush();
                }
            }
            wrMan.sendRequest(cmd);
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendAllResult(String user, String result){
        sendAllCommand("/cmdsuccess " + user + " " + result);
    }
    public void setProtocollActivated(boolean b){
        protocollActivated = b;
    }
    public boolean getProtocollActivated(){
        return protocollActivated;
    }
    public void saveProtocoll(File savePlace){
        try{
            savePlace.createNewFile();
            PrintWriter writer = new PrintWriter(new FileWriter(savePlace));
            String[] msgs = protocoll.split(";");
            for(String msg : msgs){
                writer.println(msg);
                writer.flush();
            }
            writer.close();
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void loadJokerMessages(File file){
        try{
            if(file.exists()){
                BufferedReader br = new BufferedReader(new FileReader(file));
                ArrayList<String> jokertmp = new ArrayList<String>();
                String line = null;
                while((line = br.readLine()) != null){
                    jokertmp.add(line);
                }
                br.close();
                jokerMessages = jokertmp.toArray(new String[1]);
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void sendFakeMessage(String user, String userAlias, String msg){
         try{
            Set<String> keys = clients.keySet();
            Iterator it = keys.iterator();
            while(it.hasNext()){
                String client = (String) it.next();
                Socket cliSock = clients.get(client);
                PrintWriter writer = new PrintWriter(new OutputStreamWriter(cliSock.getOutputStream()));
                writer.println(userAlias + "#" + msg);
                writer.flush();
            }
            if(protocollActivated){
                protocoll += (userAlias+"("+user+"): "+msg+";");
            }
            CMD.out.println(userAlias+"("+user+"): "+msg);
        }catch(Exception ex){ex.printStackTrace();}
    }
    public void saveAndExit(){
        forceSave();
        System.exit(0);
    }
    public void forceSave(){
        listLoader.saveList(new File("settings\\ban.ser"), bans);
        listLoader.saveList(new File("settings\\ops.ser"), ops);
        listLoader.saveList(new File("settings\\admins.ser"), admins);
    }
}
