import java.util.*;
import java.io.*;
import javax.io.*;
public class BlackListControl extends Control{
private UserList blacklist;
private ListLoader loader;
private ChatServer.BlackListAction action;
private ControlManager manager;
    public BlackListControl(){
        blacklist = ChatServer.me.getBlacklist();
        loader = ChatServer.me.getListLoader();
        action = ChatServer.me.getBlackListAction();
        manager = ChatServer.me.getControlManager();
    }
    public void handleRequest(String user, String request){
        String[] splitted = Utils.cutInput(request, 1);
        if(splitted[0].equals("/blacklist")){
            try{
                String[] reqParts = request.split(" ");
                if(reqParts[1].equals("add")){
                        try{
                            blacklist.addEntry(reqParts[2]);
                            ChatServer.me.sendAllResult(user, "Added '" + reqParts[2] + "' to Blacklist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("remove")){
                        try{
                            blacklist.remove(reqParts[2]);
                            ChatServer.me.sendAllResult(user, "Removed '" + reqParts[2] + "' from Blacklist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("enable")){
                        try{
                            blacklist.setEnabled(true);
                            ChatServer.me.sendAllResult(user, "Enabled Blacklist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("disable")){
                        try{
                            blacklist.setEnabled(false);
                            ChatServer.me.sendAllResult(user, "Disabled Blacklist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("show")){
                        try{
                            Iterator it = blacklist.iterator();
                            String clitxt = "";
                            clitxt += "Entries in the Blacklist:;";
                            while(it.hasNext()){
                                String entry = (String) it.next();
                                clitxt += entry;
                                if(it.hasNext()){
                                    clitxt += ";";
                                }
                            }
                            ChatServer.me.sendServerCommand(user, "/writemultiline " + clitxt);
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("load")){
                        try{
                            ChatServer.me.setBlackList(loader.loadList(new File("lists\\" + reqParts[2]), blacklist, action));
                            blacklist = ChatServer.me.getBlacklist();
                            ChatServer.me.sendAllResult(user, "Loaded Blacklist from '" + reqParts[2] + "'");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("save")){
                        try{
                            File savePlace = new File(reqParts[2]);
                            if(!savePlace.exists()){
                                savePlace.createNewFile();
                            }
                            loader.saveList(new File("lists\\" + reqParts[2]), blacklist);
                            ChatServer.me.sendAllResult(user, "Saved Blacklist in '" + reqParts[2] + "'");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("clear")){
                        blacklist.clear();
                        ChatServer.me.sendAllResult(user, "Cleared Blacklist");
                    }else{
                        try{
                            ChatServer.me.sendServerCommand(user, "/writeline Unsupported Operation");
                        }catch(Exception ex){ex.printStackTrace();}
                }
            }catch(Exception ex){ex.printStackTrace();}
        }else{
            this.sendToNext(user, request);
        }
    }
    public String getDescription(){
        return "/blacklist <enable/disable> :  Sets if blacklist is enabled or not;/blacklist <add/remove> <user> :  Adds or removes user 'user';/blacklist <save/load> <file> :  Saves or loads blacklist to/from file 'file';/blacklist clear :  Clears the blacklist";
    }
}
