import java.util.*;
import java.io.*;
import javax.io.*;
public class UserList implements Serializable{
private transient ListAction action;
private ArrayList<String> list;
private boolean isActive;
    public UserList(ListAction listAction){
        action = listAction;
        list = new ArrayList<String>();
        isActive = false;
    }
    public void addEntry(String entry){
        list.add(entry);
        update();
    }
    public boolean remove(String entry){
        boolean worked = list.remove(entry);
        update();
        return worked;
    }
    public boolean isUserListed(String entry){
        return list.indexOf(entry) > -1;
    }
    public void setEnabled(boolean b){
        isActive = b;
        update();
    }
    public Iterator iterator(){
        return list.iterator();
    }
    public boolean isEnabled(){
        return isActive;
    }
    public void update(){
        if(isActive){
            action.runAction(list);
        }
    }
    public void deserialize(ListAction lAction){
        action = lAction;
    }
    public void clear(){
        list.clear();
    }
}
