import java.util.*;
import java.io.*;
import javax.io.*;
public class WhiteListControl extends Control{
private UserList whitelist;
private ListLoader loader;
private ChatServer.WhiteListAction action;
private ControlManager manager;
    public WhiteListControl(){
        whitelist = ChatServer.me.getWhitelist();
        loader = ChatServer.me.getListLoader();
        action = ChatServer.me.getWhiteListAction();
        manager = ChatServer.me.getControlManager();
    }
    public void handleRequest(String user, String request){
        String[] splitted = Utils.cutInput(request, 1);
        if(splitted[0].equals("/whitelist")){
            try{
                String[] reqParts = request.split(" ");
                if(reqParts[1].equals("add")){
                        try{
                            whitelist.addEntry(reqParts[2]);
                            ChatServer.me.sendAllResult(user, "Added '" + reqParts[2] + "' to Whitelist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("remove")){
                        try{
                            whitelist.remove(reqParts[2]);
                            ChatServer.me.sendAllResult(user, "Removed '" + reqParts[2] + "' from Whitelist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("enable")){
                        try{
                            whitelist.setEnabled(true);
                            ChatServer.me.sendAllResult(user, "Enabled Whitelist");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("disable")){
                        try{
                            whitelist.setEnabled(false);
                            ChatServer.me.sendAllResult(user, "Disabled Whitelist");
                        }catch(Exception ex){ex.printStackTrace();}  
                    }else if(reqParts[1].equals("show")){
                        try{
                            Iterator it = whitelist.iterator();
                            String clitxt = "";
                            clitxt += "Entries in the Whitelist:;";
                            while(it.hasNext()){
                                String entry = (String) it.next();
                                clitxt += entry;
                                if(it.hasNext()){
                                    clitxt += ";";
                                }
                            }
                            ChatServer.me.sendServerCommand(user, "/writemultiline " + clitxt);
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("load")){
                        try{
                            ChatServer.me.setWhiteList(loader.loadList(new File("lists\\" + reqParts[2]), whitelist, action));
                            whitelist = ChatServer.me.getWhitelist();
                            ChatServer.me.sendAllResult(user, "Loaded Whitelist from '" + reqParts[2] + "'");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("save")){
                        try{
                            File savePlace = new File("lists\\" + reqParts[2]);
                            if(!savePlace.exists()){
                                savePlace.createNewFile();
                            }
                            loader.saveList(savePlace, whitelist);
                            ChatServer.me.sendAllResult(user, "Saved Whitelist in '" + reqParts[2] + "'");
                        }catch(Exception ex){ex.printStackTrace();}
                    }else if(reqParts[1].equals("clear")){
                        whitelist.clear();
                        ChatServer.me.sendAllResult(user, "Cleared Whitelist");
                    }else{
                        try{
                            ChatServer.me.sendServerCommand(user, "/writeline Unsupported Operation");
                        }catch(Exception ex){ex.printStackTrace();}
                    }
            }catch(Exception ex){ex.printStackTrace();}
        }else{
            this.sendToNext(user, request);
        }
    }
     public String getDescription(){
        return "/whitelist <enable/disable> :  Sets if whitelist is enabled or not;/whitelist <add/remove> <user> :  Adds or removes user 'user';/blacklist <save/load> <file> :  Saves or loads whitelist to/from file 'file';/whitelist clear :  Clears the whitelist";
    }
}

