package javax.io;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
/**
 * Diese Klasse stellt alle Funktionen der Kommandozeile bereit.
 */
public class CMD {
    static JTextArea console;
    static JTextField inputField;
    static String input;
    static JButton button;
    static boolean buttonDisabling;
    /**
     * Der Eingabestrom.
     */
    public static In in = new In();
    /**
     * Der Ausgabestrom.
     */
    public static Out out = new Out();
    /**
     * Reprsentiert die Anzahl der aktiven Fenster.
     */
    static int windowActive = 0;
    static JFrame frame;
    /**
     * Diese Klasse berprft den Status des Buttons.
     */
    class ButtonHandler implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            if (inputField.getText() != null) {
                input = inputField.getText();
                if(buttonDisabling){
                    button.setEnabled(false);
                }
            }
        }
    }
        /**
         * Diese Methode setzt die Listener.
         */
    void setButtonListener(CMD CMD) {
        button.addActionListener(new ButtonHandler());
        frame.addWindowListener(new MeinCMDListener());
        }

    protected CMD() {};
    public static void createWindow(){
        createWindow("CMD");
    }

 /**
  * Erstellt das Fenster, dass zum Ausfhren der Befehle gebraucht wird.
  *
  */
 public static void createWindow(String name) {        //erstellt das Fenster
        frame = new JFrame(name);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setButtonDisabling(true);
        frame.setResizable(false);
        frame.setSize(400,500);
        button = new JButton("Write");
        button.setEnabled(false);
        CMD sys = new CMD();
        sys.setButtonListener(sys);
        console = new JTextArea(15,30);
        console.setEditable(false);
        console.setLineWrap(true);
        inputField = new JTextField(25);
        sys.setKeyListener();
        JPanel panel = new JPanel();
        JPanel panel2 = new JPanel();
        JScrollPane sbar = new JScrollPane(console);
        JScrollPane sbarin = new JScrollPane(inputField);
        sbar.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        sbar.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        sbarin.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        sbarin.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        panel2.setLayout(new BoxLayout(panel2, BoxLayout.X_AXIS));
        panel2.setAlignmentY(Component.CENTER_ALIGNMENT);
        panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
        panel.setAlignmentY(Component.CENTER_ALIGNMENT);
        panel2.add(sbar);
        panel.add(inputField);
        panel.add(button);
        frame.getContentPane().add(BorderLayout.CENTER, panel2);
        frame.getContentPane().add(BorderLayout.SOUTH, panel);
        frame.setVisible(true);
        windowActive += 1;
        }
        /**
         * Diese Klasse berprft den Status des Fensters.
         */
    class MeinCMDListener implements WindowListener {
        public void windowClosed(WindowEvent e){
            windowActive -= 1;
        }
        public void windowActivated(WindowEvent e){}
        public void windowClosing(WindowEvent e){}
        public void windowDeactivated(WindowEvent e){}
        public void windowDeiconified(WindowEvent e){}
        public void windowIconified(WindowEvent e){}
        public void windowOpened(WindowEvent e){}
    }
    class EnterListener implements KeyListener{
        public void keyPressed(KeyEvent e){
            if (e.getKeyCode() == KeyEvent.VK_ENTER){
                CMD.button.doClick();
            }
        }
        public void keyTyped(KeyEvent e){}
        public void keyReleased(KeyEvent e){}
    }
    void setKeyListener(){
        inputField.addKeyListener(new EnterListener());
    }
        /**
         * Die Methode baut das Fenster auf, wenn das Package gestartet wird.
         */
    public static void main(String[] args) {
        createWindow();     //falls als Package gestartet, wird trotzdem das Fenster erstellt (allerdings nutzlos)
        
        }

    public static void setButtonEnabled(JButton b, boolean e) {
        b.setEnabled(e);
    }
    public static void addWindowListener(WindowListener l){
        frame.addWindowListener(l);
    }
    public static void addKeyListener(KeyListener l){
        frame.addKeyListener(l);
    }
    public static void setButtonDisabling(boolean bool){
        buttonDisabling = bool;
    }
    public static void setWrapStyleWord(boolean bool){
        console.setWrapStyleWord(bool);
    }
}
    
