package javax.io.console;
import javax.io.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * 
 */
public class Console{
    /**
     * Der Eingabestrom.
     */
    public static ConsoleInput in = new ConsoleInput();
    /**
     * Der Ausgabestrom.
     */
    public static ConsoleOutput out = new ConsoleOutput();
    /**
     * Der Fehlerstrom.
     */
    public static ConsoleError err = new ConsoleError();
    protected Console(){}
    public static void main(String[] args){
        new Console().start();
    }
    /**
     * Baut eine voll funktionsfhige Kommandozeile auf.
     */
    public static void start(){
        try{
            Console con = new Console();
            CMD.createWindow();
            ConsoleConnector.connect();
            con.startThread();
            deliverWritings();
        }catch(ConnectionException ex){ex.printStackTrace();}
    }
    /**
     * Startet die erforderlichen Threads.
     */
    void startThread(){
        Thread t = new Thread(new Job());
        Thread t2 = new Thread(new Job2());
        t.start();
        t2.start();
    }
    /**
     * Schickt Eingaben des Benutzers an die Kommandozeile.
     */
    static void deliverWritings(){
        try{
            while(true){
                ConsoleConnector.writer.write(CMD.in.readLine());
                ConsoleConnector.writer.newLine();
                ConsoleConnector.writer.flush();
            }
        }catch(Exception ex){ex.printStackTrace();}
    }
    /**
     * Diese Klasse liest Antworten der Kommandozeile.
     */
    class Job implements Runnable{
        public void run(){
            try{
                String input;
                while((input = ConsoleConnector.reader.readLine()) != null){
                    CMD.out.println(input);
                }
            }catch(Exception ex){ex.printStackTrace();}
        }
    }
    /**
     * Diese Klasse liest Fehler auf der Kommandozeile.
     */
    class Job2 implements Runnable{
        public void run(){
            try{
                String input;
                while((input = ConsoleConnector.error.readLine()) != null){
                    CMD.out.println(input);
                }
            }catch(Exception ex){ex.printStackTrace();}
        }
    }
}
