package javax.io.console;
import java.io.*;
/**
 * Diese Klasse beinhaltet alle Schreibmethoden.
 */
public class ConsoleOutput{
    ConsoleOutput(){}
    /**
     * Schreibt eine Zeile auf die Kommandozeile (meistens einen Befehl).
     * @param  command   Ein String, der die zu schreibende Zeile oder den Befehl mit/ohne Argumente enthlt
     */
    static void runCommand(String command) throws ConnectionException{
        if (ConsoleConnector.connected){
            try{
                ConsoleConnector.writer.write(command);
                ConsoleConnector.writer.newLine();
                ConsoleConnector.writer.flush();
            }catch(IOException ex){ex.printStackTrace();}
        }else{
            throw new ConnectionException("There is no connection to a running Terminal");
        }
    }
    /**
     * Schreibt eine Zeile auf die Kommandozeile (meistens einen Befehl).
     * @param  command[]   Ein Array, dass den Befehl und die Eingabeargumente enthlt
     */
    static void runCommand(String[] command) throws ConnectionException{
        String cmdString = null;
        for (int i=0;i<command.length;i++){
            String arg = command[i];
            cmdString = cmdString + " " + arg;
        }
        ConsoleOutput.runCommand(cmdString);
    }
    /**
     * Schreibt Text auf die Kommandozeile.
     * @param  txt   Der zu schreibende Text
     */
    static void write(String txt) throws ConnectionException{
        if (ConsoleConnector.connected){
            try{
                ConsoleConnector.writer.write(txt);
                ConsoleConnector.writer.flush();
            }catch(IOException ex){ex.printStackTrace();}
        }else{
            throw new ConnectionException("There is no connection to a running Terminal");
        }
    }
    /**
     * Leert die Konsole.
     */
    static void clearConsole() throws ConnectionException{
        ConsoleOutput.runCommand("\f");
    }
}
